<?php
//**************************************************************
// DESCRIPTION
// Home page of SIGOF
// * print Total number of events
// * print Total number of events by sensor
//**************************************************************
//  CREATION :
// Le 08/04/06 : Creation C. Trussardi
//**************************************************************


//Includes
include("utiles.inc");

//Connect to SGBD
$db = new DB(HOST,USERNAME,PASSWORD,DBNAME);

top();

menu();

echo "\n";

echo "<!-- DEBUT CONTENTS -->\n";
echo "<div id=\"contents\">\n";

echo "<h2><a class=\"anchor\" name=\"top\">Total number of events :</a></h2>\n";

$stats=getStats($db);
echo "<table class=\"consultation\">\n";
echo "<th># of events in the database</th><th>First event logged at</th><th>Last event logged at</th>\n";
echo "<tr class=\"bright\">\n";
echo "<td>".$stats["total_number"]."</td><td>".$stats["min_timestamp"]."</td><td>".$stats["max_timestamp"]."</td>\n";
echo "</table>\n";

echo "<h2>Total number of events by sensor :</h2>\n";

echo "<table class=\"consultation\">\n";
echo "<tr>\n";
echo "<th>Sensor</th><th># of events</th><th>First event detected at</th><th>Last event detected at</th>\n";
echo "</tr>\n";
$i=0;
foreach (getSensorArray("home",$db) as $sensor)
{
	$style=($i ? "dark" : "bright");
	echo "<tr class=\"".$style."\">\n";
	echo "<td>".$sensor["sensor"]."</td><td>".$sensor["total_number"]."</td><td>".$sensor["min_timestamp"]."</td><td>".$sensor["max_timestamp"]."</td>\n";
	echo "</tr>\n";
	$i = 1 - $i;
}//foreach
echo "</table>\n";
	
echo "</div>\n";
echo "<!--END CONTENTS-->\n";

footer();

?>