<?php
//********************************************
// DESCRIPTION
// Classe d'interface avec un SGBD
//********************************************
// CREATION :
// 08/04/06 : C. Trussardi
//********************************************


class DB {

	var $host;
	var $username;
	var $password;
	var $dbname;
	
	var $connection;
	var $disconnection;
	var $numrows;
	var $numcols;
	var $message;

	var $column_names;
	var $column_types;
	var $column_sizes;


	//******************************************************************************
	function DB($DBhost,$DBusername,$DBpassword,$DBdbname)
	//Connection to DB
	{
		$this->host = $DBhost;
		$this->username = $DBusername;
		$this->password = $DBpassword;
		$this->dbname = $DBdbname;
		
		if (!$this->connection)
		{
			$this->connection = mysql_connect($this->host, $this->username, $this->password)
				or die("Erreur de connection  la base de donnes.");

			mysql_select_db($this->dbname) or die("Erreur de connection  la base de donnes.");
		}
	} // function DB
	
	
	//****************************************************************************
	function query($query)
	//Send a query to DB
	{
		$result = false;
		$message_sing = "";
		$message_plur = "";

		$array = (array) null;

		$this->column_names = (array) null;
		$this->column_types = (array) null;
		$this->column_sizes = (array) null;

		$this->numrows = 0;
		$this->numcols = 0;

		$result = mysql_query($query,$this->connection) or die("Erreur dans la requte : " . $query . mysql_error());

		if (strcmp(strtoupper(substr($query, 0, 6)), "INSERT") == 0)
		{
			$this->numrows = mysql_affected_rows();
			$message_sing = "ligne cre.";
			$message_plur = "lignes cres.";
		}
		elseif (strcmp(strtoupper(substr($query, 0, 6)), "SELECT") == 0)
		{
			while ($row = mysql_fetch_array($result, MYSQL_ASSOC))
			{
  				$array[] = $row;
			}

			$this->numcols = mysql_num_fields($result);

			for ($i = 0; $i < $this->numcols; $i++)
			{
				$this->column_names[$i] = mysql_field_name($result, $i);
				$this->column_types[$i] = mysql_field_type($result, $i);
				$this->column_sizes[$i] = mysql_field_len($result, $i);
			}

			$this->numrows = mysql_num_rows($result);
			$message_sing = "ligne slectionne.";
			$message_plur = "lignes slectionnes.";

			mysql_free_result($result);
		}
		elseif (strcmp(strtoupper(substr($query, 0, 6)), "UPDATE") == 0)
		{
			$this->numrows = mysql_affected_rows();
			$message_sing = "ligne mise  jour.";
			$message_plur = "lignes mises  jour.";
		}
		elseif (strcmp(strtoupper(substr($query, 0, 6)), "DELETE") == 0)
		{
			$this->numrows = mysql_affected_rows();
			$message_sing = "ligne supprime.";
			$message_plur = "lignes supprimes.";
		}
		$this->message = $this->numrows . " " . ($this->numrows > 1 ? $message_plur : $message_sing);

		return $array;
	} // function query($query)

	
	//****************************************************************************
	function number_rows($query)
	//Soumission d'une requte au SGBD
	{
		$result = false;
		$message_sing = "";
		$message_plur = "";

		$this->column_names = (array) null;
		$this->column_types = (array) null;
		$this->column_sizes = (array) null;

		$this->numrows = 0;

		$result = mysql_query($query,$this->connection) or die("Erreur dans la requte : " . $query . mysql_error());

		if (strcmp(strtoupper(substr($query, 0, 6)), "SELECT") == 0)
		{
			$this->numrows = mysql_num_rows($result);
			$message_sing = "ligne slectionne.";
			$message_plur = "lignes slectionnes.";

			mysql_free_result($result);
		}
	
		$this->message = $this->numrows . " " . ($this->numrows > 1 ? $message_plur : $message_sing);
		
		return $this->numrows;
	} // function number_rows($query)
	
} // class DB

?>
