<?php
//*****************************************************
// DESCRIPTION
// Design functions for the whole application
// * header, menu, etc ...
//*****************************************************
// CREATION :
// 08/04/06 : C. Trussardi
//*****************************************************


//******************************************************************************
function top ()
// create and print header
{
	//META-TAGS
	echo "<!-- BEGIN META-TAGS -->\n";
	echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n";
	echo "<html xmlns=\"http://www.w3.org/1999/xhtml\" lang=\"en\" xml:lang=\"en\">\n";
	echo "<head>\n";
	echo "<meta http-equiv=\"Content-type\" content=\"text/html; charset=iso-8859-15\" />\n";
	echo "<title>".APPLICATION_TITLE."</title>\n";
	echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"".URL."/styles/styles.css\" />\n";
	echo "</head>\n";
	echo "<!-- END META-TAGS -->\n";
	echo "\n";
	echo "<body>\n";
	echo "\n";
	echo "<!-- BEGIN CONTAINER -->\n";
	echo "<div id=\"container\">\n";
	echo "\n";
	echo "".TITLE."\n";
	echo "\n";
}//function top()


//******************************************************************************
function createMenu ()
// create menu
{
	//gnric menus for everybody
	$menu['name'] = array("Home","RRDs","Tops","Graphs","Search");
	$menu['url'] = array("home.php","rrds.php","tops.php","graphs.php","search.php");
	
	return ($menu);
}//function createMenu


//******************************************************************************
function menu()
// print menu
{
	$menu = createMenu();
	
	echo "<!-- BEGIN MENU -->\n";
	echo "<div id=\"menu\">\n";
	echo "<div id=\"tabs\">\n";
	echo "<ul>\n";
	for ($i=0; $i < count($menu['url']); $i++)
	{
		//Current tab is highlighted
		if ($menu['url'][$i] === substr($_SERVER['PHP_SELF'], strlen(ROOT)))
		{
			$tabClass = "current";
		}
		else
		{
			$tabClass = "";
		}//fi
		
		echo "<li class=\"".$tabClass."\"><a class=\"tabLink\" href=\"".$menu['url'][$i]."\">".$menu['name'][$i]."</a></li>\n";
	}//for

	echo "</ul>\n";
	echo "</div>\n";
	echo "</div>\n";
	echo "<!-- END MENU -->\n";
}//function menu


//******************************************************************************
function footer()
// create and print footer
{
	echo "\n";
	echo "<p id=\"leftFooter\">Version : ".VERSION_NUMBER."</p>\n";
	echo "<p id=\"rightFooter\">|  <a href=\"#top\">Top</a>  |  <a href=\"javascript:history.back();\">Back</a>  |</p>\n";
	echo "\n";
	echo "</div>\n";
	echo "<!-- END CONTAINER -->\n";
	echo "\n";
	echo "</body>\n";
	echo "</html>\n";
	exit;
}//function footer()
?>