<?php
//**************************************************************
// DESCRIPTION
// Do a search thanks to different fields and print results
//**************************************************************
//  CREATION :
// Le 08/04/06 : Creation C. Trussardi
//**************************************************************


//Includes
include("utiles.inc");

//Connect to SGBD
$db = new DB(HOST,USERNAME,PASSWORD,DBNAME);

top();

menu();

echo "\n";

echo "<!-- BEGIN CONTENTS -->\n";
echo "<div id=\"contents\">\n";

echo "<h2><a class=\"anchor\" name=\"top\">Search</a></h2>\n";

//The form has been submitted
if (postvars('validation'))
{
	$arguments=array("sensor","sigclass","signature","pre_signature","spade_signature","fulltextop","keyword","ipaddress","direction","directionop","severity","protocol","order","wport","port","hour","day","month","year","minute","when","order","offset","way","limit");
	foreach ($arguments as $argument)
	{
		if (postvars($argument))
		{
			$$argument=$_POST[$argument];
		}
		else
		{
			$$argument="";
		}
	}//foreach
}//fi 

echo "<!-- Begin form -->\n";
echo "<form method=\"post\" action=\"".$_SERVER["PHP_SELF"]."#table\">\n";
echo "<table class=\"input\">\n";
echo "<tr>\n";
echo "<td>Sensor :</td>\n";

//Sensor field
echo "<td><select name=\"sensor\" size=\"1\">\n";
echo "<option value=\"\">All</option>\n";
foreach (getSensorArray("tops",$db) as $getSensor)
{
	(postvars('validation') && ($sensor === $getSensor["sid"])) ? $sensorField="<option selected=\"selected\" value=\"".$getSensor["sid"]."\">" : $sensorField="<option value=\"".$getSensor["sid"]."\">"; echo $sensorField."".$getSensor["hostname"]."</option>\n";
}//foreach
echo "</select></td>\n";

echo "</tr><tr>\n";

//Class field
echo "<td>Class :</td><td><select name=\"sigclass\" size=\"1\">\n";
echo "<option value=\"\">All</option>\n";
foreach (getClasses($db) as $getClass)
{
	(postvars('validation') && ($sigclass === $getClass["sig_class_id"])) ? $classField="<option selected=\"selected\" value=\"".$getClass["sig_class_id"]."\">" : $classField="<option value=\"".$getClass["sig_class_id"]."\">"; echo $classField."".$getClass["sig_class_name"]."</option>\n";
}//foreach
echo "</select></td>\n";

//Severity field
echo "<td>Severity :</td><td><select name=\"severity\" size=\"1\">\n";
echo "<option value=\"\">All</option>\n";
(postvars('validation') && ($severity == "3" )) ? $severityField="<option selected=\"selected\" value=\"3\">" : $severityField="<option value=\"3\">"; echo $severityField."Low</option>\n";
(postvars('validation') && ($severity == "2" )) ? $severityField="<option selected=\"selected\" value=\"2\">" : $severityField="<option value=\"3\">"; echo $severityField."Medium</option>\n";
(postvars('validation') && ($severity == "1" )) ? $severityField="<option selected=\"selected\" value=\"1\">" : $severityField="<option value=\"3\">"; echo $severityField."High</option>\n";
echo "</select></td>\n";

echo "</tr></table><table class=\"input\"><tr>\n";

//Rule Signature field
echo "<td>Rule Signature</td><td><select name=\"signature\" size=\"1\">\n";
echo "<option value=\"\">All</option>\n";
foreach (getSignatures("rule",$db) as $getRuleSignature)
{
	(postvars('validation') && ($signature === $getRuleSignature["sig_name"])) ? $ruleSignatureField="<option selected=\"selected\" value=\"".$getRuleSignature["sig_name"]."\">" : $ruleSignatureField="<option value=\"".$getRuleSignature["sig_name"]."\">"; echo $ruleSignatureField."".$getRuleSignature["sig_name"]."</option>\n";
}//foreach
echo "</select></td>\n";

echo "</tr><tr>\n";

//Preprocessor Signature field
echo "<td>Preprocessor Signature</td><td><select name=\"pre_signature\" size=\"1\">\n";
echo "<option value=\"\">All</option>\n";
foreach (getSignatures("preprocessor",$db) as $getPreprocessorSignature)
{
	(postvars('validation') && ($pre_signature === $getPreprocessorSignature["sig_name"])) ? $preprocessorSignatureField="<option selected=\"selected\" value=\"".$getPreprocessorSignature["sig_name"]."\">" : $preprocessorSignatureField="<option value=\"".$getPreprocessorSignature["sig_name"]."\">"; echo $preprocessorSignatureField."".$getPreprocessorSignature["sig_name"]."</option>\n";
}//foreach
echo "</select></td>\n";

//Spade Signature field
echo "<td>SPADE alerts</td><td><select name=\"spade_signature\" size=\"1\">\n";
echo "<option value=\"\">All</option>\n";
foreach (getSignatures("spade",$db) as $getSpadeSignature)
{
	(postvars('validation') && ($spade_signature === $getSpadeSignature["sig_name"])) ? $spadeSignatureField="<option selected=\"selected\" value=\"".$getSpadeSignature["sig_name"]."\">" : $spadeSignatureField="<option value=\"".$getSpadeSignature["sig_name"]."\">"; echo $spadeSignatureField."".$getSpadeSignature["sig_name"]."</option>\n";
}//foreach
echo "</select></td>\n";

echo "</tr><tr>\n";

//Fulltextop field
echo "<td>Full text search in signature</td><td><select name=\"fulltextop\" size=\"1\">\n";
echo "<option value=\"\">--</option>\n";
(postvars('validation') && ($fulltextop === "begins" )) ? $fulltextopField="<option selected=\"selected\" value=\"begins\">" : $fulltextopField="<option value=\"begins\">"; echo $fulltextopField."Begins</option>\n";
(postvars('validation') && ($fulltextop === "contains" )) ? $fulltextopField="<option selected=\"selected\" value=\"contains\">" : $fulltextopField="<option value=\"contains\">"; echo $fulltextopField."Contains</option>\n";
(postvars('validation') && ($keyword != "")) ? $keywordField="</select><input type=\"text\" name=\"keyword\" value=\"".$keyword."\" /></td>\n" : $keywordField="</select><input type=\"text\" name=\"keyword\" /></td>\n"; echo $keywordField;

echo "</tr></table><table class=\"input\"><tr>\n";

//Address field
echo "<td>Address</td><td><select name=\"direction\" size=\"1\">\n";
echo "<option value=\"both\">Src or Dst</option>\n";
(postvars('validation') && ($direction === "src" )) ? $directionField="<option selected=\"selected\" value=\"src\">" : $directionField="<option value=\"src\">"; echo $directionField."Source</option>\n";
(postvars('validation') && ($direction === "dst" )) ? $directionField="<option selected=\"selected\" value=\"dst\">" : $directionField="<option value=\"dst\">"; echo $directionField."Dest.</option>\n";
echo "</select></td>\n";

echo "<td><select name=\"directionop\" size=\"1\">\n";
echo "<option selected=\"selected\" value=\"eq\">=</option>\n";
(postvars('validation') && ($directionop === "like" )) ? $directionopField="<option selected=\"selected\" value=\"like\">" : $directionopField="<option value=\"like\">"; echo $directionopField."LIKE</option>\n";
echo "</select></td>\n";

(postvars('validation') && ($ipaddress != "")) ? $ipaddressField="<td><input type=\"text\" name=\"ipaddress\" value=\"".$ipaddress."\" /></td>\n" : $ipaddressField="<td><input type=\"text\" name=\"ipaddress\" /></td>\n"; echo $ipaddressField;

echo "</tr><tr>\n";

//Protocol field
echo "<td>Protocol</td><td><select name=\"protocol\" size=\"1\">\n";
echo "<option value=\"\">All</option>\n";
(postvars('validation') && ($protocol == "6" )) ? $protocolField="<option selected=\"selected\" value=\"6\">" : $protocolField="<option value=\"6\">"; echo $protocolField."TCP</option>\n";
(postvars('validation') && ($protocol == "17" )) ? $protocolField="<option selected=\"selected\" value=\"17\">" : $protocolField="<option value=\"17\">"; echo $protocolField."UDP</option>\n";
(postvars('validation') && ($protocol == "1" )) ? $protocolField="<option selected=\"selected\" value=\"1\">" : $protocolField="<option value=\"1\">"; echo $protocolField."ICMP</option>\n";
(postvars('validation') && ($protocol === "other" )) ? $protocolField="<option selected=\"selected\" value=\"dst\">" : $protocolField="<option value=\"other\">"; echo $protocolField."Other</option>\n";
echo "</select></td>\n";

echo "</tr><tr>\n";

//Port field
echo "<td>Port</td><td><select name=\"wport\" size=\"1\">\n";
echo "<option value=\"both\">Src or Dst</option>\n";
(postvars('validation') && ($wport === "src" )) ? $wportField="<option selected=\"selected\" value=\"src\">" : $wportField="<option value=\"src\">"; echo $wportField."Source</option>\n";
(postvars('validation') && ($wport === "dst" )) ? $wportField="<option selected=\"selected\" value=\"dst\">" : $wportField="<option value=\"dst\">"; echo $wportField."Dest.</option>\n";
echo "</select></td>\n";

echo "<td><input type=\"text\" name=\"port\" /></td>\n";

echo "</tr></table><table class=\"input\"><tr>\n";

//When field
echo "<td>Detected at :</td>\n";
echo "<td><select name=\"when\" size=\"1\">\n";
echo "<option value=\"\">--</option>\n";
(postvars('validation') && ($when === "LIKE" )) ? $whenField="<option selected=\"selected\" value=\"LIKE\">" : $whenField="<option value=\"LIKE\">"; echo $whenField."at</option>\n";
(postvars('validation') && ($when == ">" )) ? $whenField="<option selected=\"selected\" value=\">\">" : $whenField="<option value=\">\">"; echo $whenField."after</option>\n";
(postvars('validation') && ($when == "<" )) ? $whenField="<option selected=\"selected\" value=\"<\">" : $whenField="<option value=\"<\">"; echo $whenField."before</option>\n";
echo "</select></td>\n";

//Day Field
echo "<td><select name=\"day\">\n";
for ($i=1; $i<32; $i++)
{
	(postvars('validation') && ($day == "$i")) ? $dayField="<option selected=\"selected\" value=\"".$i."\">" : $dayField="<option value=\"".$i."\">";
	echo "".$dayField.$i."</option>\n";
}//for
echo "</select></td>\n";

//Month Field
echo "<td><select name=\"month\">\n";
foreach (getDateList("month",$db) as $date)
{
	(postvars('validation') && ($month === $date["month"])) ? $thismonthField="<option selected=\"selected\" value=\"".$date["month"]."\">" : $thismonthField="<option value=\"".$date["month"]."\">";
	echo "".$thismonthField.$date["monthname"]."</option>\n";
}//foreach
echo "</select></td>\n";

//Year Field
echo "<td><select name=\"year\">\n";
foreach (getDateList("year",$db) as $date)
{
	(postvars('validation') && ($year === $date["year"])) ? $thisyearField="<option selected=\"selected\" value=\"".$date["year"]."\">" : $thismonthField="<option value=\"".$date["year"]."\">";
	echo "".$thismonthField.$date["year"]."</option>\n";
}//foreach
echo "</select></td>\n";

echo "<td>At</td>\n";

//Hour Field
echo "<td><select name=\"hour\">\n";
echo "<option value=\"\">--</option>\n";
for ($i=0; $i<24; $i++)
{
	(postvars('validation') && ($hour == "$i")) ? $hourField="<option selected=\"selected\" value=\"".$i."\">" : $hourField="<option value=\"".$i."\">";
	echo "".$hourField.$i."</option>\n";
}//for
echo "</select></td><td>hh</td>\n";

//Minute Field
echo "<td><select name=\"minute\">\n";
echo "<option value=\"\">--</option>\n";
for ($i=0; $i<60; $i++)
{
	(postvars('validation') && ($minute == "$i")) ? $minuteField="<option selected=\"selected\" value=\"".$i."\">" : $minuteField="<option value=\"".$i."\">";
	echo "".$minuteField.$i."</option>\n";
}//for
echo "</select></td><td>mn</td>\n";

echo "</tr><tr>\n";

//Order by Field
echo "<td>Ordered by :</td>\n";
echo "<td><select name=\"order\" size=\"1\">\n";
(postvars('validation') && ($order == "timestamp" )) ? $orderField="<option selected=\"selected\" value=\"timestamp\">" : $orderField="<option value=\"timestamp\">"; echo $orderField."Detection Time</option>\n";
(postvars('validation') && ($order == "severity" )) ? $orderField="<option selected=\"selected\" value=\"severity\">" : $orderField="<option value=\"severity\">"; echo $orderField."Severity</option>\n";
(postvars('validation') && ($order == "sig_name" )) ? $orderField="<option selected=\"selected\" value=\"sig_name\">" : $orderField="<option value=\"sig_name\">"; echo $orderField."Signature</option>\n";
(postvars('validation') && ($order === "INET_NTOA(ip_src)" )) ? $orderField="<option selected=\"selected\" value=\"INET_NTOA(ip_src)\">" : $orderField="<option value=\"INET_NTOA(ip_src)\">"; echo $orderField."Source</option>\n";
(postvars('validation') && ($order === "INET_NTOA(ip_dst)" )) ? $orderField="<option selected=\"selected\" value=\"INET_NTOA(ip_dst)\">" : $orderField="<option value=\"INET_NTOA(ip_dst)\">"; echo $orderField."Destination</option>\n";
echo "</select></td>\n";

//Way Field
echo "<td><select name=\"way\" size=\"1\">\n";
(postvars('validation') && ($way == "DESC" )) ? $wayField="<option selected=\"selected\" value=\"DESC\">" : $wayField="<option value=\"DESC\">"; echo $wayField."Descending</option>\n";
(postvars('validation') && ($way == "ASC" )) ? $wayField="<option selected=\"selected\" value=\"ASC\">" : $wayField="<option value=\"ASC\">"; echo $wayField."Ascending</option>\n";
echo "</select></td>\n";


//Limit Field
echo "<td>Show</td>";
(postvars('validation') && ($limit != "")) ? $limitField="<td><input type=\"text\" name=\"limit\" value=\"".$limit."\" /></td>" : $limitField="<td><input type=\"text\" name=\"limit\" value=\"50\" /></td>"; echo $limitField;
echo "<td>Per page</td></tr>\n";


echo "<tr><td class=\"button\" colspan=\"10\"><input type=\"hidden\" name=\"validation\" value=\"1\" /><input type=\"submit\" value=\"Submit\" /></td></tr>\n";
echo "</table>\n";

echo "</form>\n";
echo "<!-- End form -->\n";

//The form has been submitted
if (postvars('validation'))
{
	//Protect arguments against SQL injection
	foreach ($arguments as $argument)
	{
		if (postvars($argument))
		{
			$$argument=quote_smart($_POST[$argument]);
			$argsArray["".$argument.""]=quote_smart($_POST[$argument]);
		}
		else
		{
			$$argument="";
			$argsArray["".$argument.""]="";
		}
	}//foreach
	
	if (postvars('next')) {
		$offset = $offset + $limit;
		$argsArray["offset"] = $argsArray["offset"] + $argsArray["limit"];
	}//fi
	
	if (postvars('previous')) {
		$offset = $offset - $limit;
		$argsArray["offset"] = $argsArray["offset"] - $argsArray["limit"];
	}//fi

	$result=getSearchResults($argsArray,$db);
	$searchResults=$result["data"];
	$searchResultsNumber=$result["number"];

	//If results, print them
	if (count($searchResults)>0)
	{
		echo "<a name=\"table\"><table class=\"consultation\">\n";
		echo "<tr>\n";
		echo "<th>id</th><th>Severity</th><th>Detection time</th><th>Signature</th><th>Source</th><th>Dest.</th>\n";
		echo "</tr>\n";
	
		$i = 0;
		$events_id=array();
		foreach($searchResults as $searchResult)
		{
			$events_id[]=$searchResult["cid"];
			$style=($i ? "dark" : "bright");
			echo "<tr class=\"".$style."\">\n";
			echo "<td><a href=\"details.php?alert_id=".$searchResult["cid"]."\" title=\"View details\" onclick=\"javascript:window.open(this.href,'','height=600, width=800, top=10, left=10, toolbar=no, menubar=yes, location=no, resizable=yes, scrollbars=no, status=no');return false;\">".$searchResult["cid"]."</a></td><td>".$searchResult["sig_priority"]."</td><td>".$searchResult["timestamp"]."</td><td>".$searchResult["sig_name"]."</td><td>".$searchResult["src"]."</td><td>".$searchResult["dst"]."</td>\n";
			echo "</tr>\n";
			$i = 1 - $i;
		}//foreach

		$minimum = $offset + 1;
		$maximum = $offset + $limit;
		if ($maximum > $searchResultsNumber) {
			$maximum = $searchResultsNumber;
		}//fi
	
		echo "</table></a>\n";
	
		//Form for multipage
		echo "<form method=\"post\" action=\"".$_SERVER["PHP_SELF"]."#table\">\n";
		echo "<table class=\"traverse\">\n";
		echo "<tr>\n";
		echo "<td>Display ".$minimum." - ".$maximum." (Total : ".$searchResultsNumber.")</td>\n";
		echo "</tr><tr>\n";
		echo "<td class=\"button\">\n";
		foreach ($argsArray as $keyArg => $valueArg)
		{
			$valueArg=str_replace("'","",$valueArg);
			echo "<input type=\"hidden\" name=\"".$keyArg."\" value=\"".$valueArg."\" />\n";
		}//foreach
	
		echo "<input type=\"hidden\" name=\"validation\" value=\"1\" />\n";
	
		//Display "Next" / "Previous" button if needed
		if ($argsArray["offset"] >= $limit) {
			echo "<input type=\"submit\" name=\"previous\" value=\"Previous\" />\n";
		}//fi
	
		if ($argsArray["offset"] + $limit < $searchResultsNumber) {
			echo "<input type=\"submit\" name=\"next\" value=\"Next\" /></td></tr>\n";
		}//fi
		
		echo "</table></form>\n";
		
	} else {
		//No data
		echo "<p class=\"warning\">No data</p>\n";
	}//fi
}//fi

echo "</div>\n";
echo "<!--END CONTENTS-->\n";

footer();

?>