<?php
//*********************************************
// DESCRIPTION
// Page called from tops.php to print proportionnal graphic
//********************************************
// CREATION :
// 04/08/06 : Cration C. Trussardi
//********************************************


//Includes
include("utiles.inc");

$dataArray=unserialize(urldecode($_GET["dataArray"]));
$top=$_GET["top"];

foreach($dataArray as $dataRow)
{
	$data[] = $dataRow["total"];
	switch($top)
	{
		case "'msalr'" :
			$leg[] = $dataRow["signature"];
		break;
		case "'mssrc'" :
			$leg[] = $dataRow["source"];
		break;
		case "'msdst'" :
			$leg[] = $dataRow["target"];
		break;
	}//switch
}//foreach
	
$date = date("F j, Y, g:i a");

$graph = new PieGraph(690,250,"auto");

if ($_GET['title']) 
{
	$label = urldecode($_GET['title']);
	$graph->title->Set("$label - Graph generated on $date");
}
$graph->title->SetFont(FF_FONT1,FS_BOLD);

$p1 = new PiePlot($data);
$p1->SetSize(.3);
$p1->SetCenter(0.2);

$p1->SetTheme("sand");

$p1->SetLegends($leg);
$p1->SetShadow();
	
$p1->value->SetFont(FF_FONT1,FS_BOLD);
$p1->value->SetColor("black");
$p1->SetLabelType(PIE_VALUE_PER);

$a = array_search(max($data),$data); //Find the position of  maixum value.

$graph->Add($p1);
$graph->Stroke();
?>