<?php
//*********************************************
// DESCRIPTION
// Page called from sear.php to print details on a particular packet
//********************************************
// CREATION :
// 24/04/06 : Creation C. Trussardi
//********************************************


//Includes
include("utiles.inc");

//Connect to SGBD
$db = new DB(HOST,USERNAME,PASSWORD,DBNAME);

$alert_cid=$_GET["alert_id"];

$array=getEventDetails($alert_cid,$db);

foreach($array as $key=>$value)
{
	if(isset($array[$key])) 
	{
		$$key=$value;
	} else {
		$$key="";
	}//fi
}//foreach


echo "<!-- BEGIN META-TAGS -->\n";
echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n";
echo "<html xmlns=\"http://www.w3.org/1999/xhtml\" lang=\"en\" xml:lang=\"en\">\n";
echo "<head>\n";
echo "<meta http-equiv=\"Content-type\" content=\"text/html; charset=iso-8859-15\" />\n";
echo "<title>".APPLICATION_TITLE."</title>\n";
echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"".URL."/styles/styles.css\" />\n";
echo "</head>\n";
echo "<!-- END META-TAGS -->\n";
echo "\n";
echo "<body>\n";
echo "\n";

echo "<table class=\"consultation\">\n";

echo "<tr><th class=\"dark\" colspan=\"5\">Summary</th></tr>\n";
echo "<tr><th>Signame</th><th>Severity</th><th>Class</th><th>Detected at</th><th>By sensor</th></tr>\n";
echo "<tr class=\"dark\"><td>".$event_name."</td><td>".$event_severity."</td><td>".$sig_class_name."</td><td>".$timestamp."</td><td colspan=\"2\">".$sensor."</td></tr>\n";

echo "<tr><th class=\"dark\" colspan=\"5\">Details</th></tr>\n";
echo "<tr><th>Source</th><th>Source port</th><th>Destination</th><th>Dest. port</th><th>Proto</th>\n";
echo "<tr class=\"dark\"><td>".$source."</td><td>".$source_port."</td><td>".$destination."</td><td>".$destination_port."</td><td>".$protocol."</td>\n";

if (isset($payload))
{
	echo "<tr><th class=\"dark\" colspan=\"5\">Packet payload</th></tr>\n";
	echo "<tr class=\"dark\"><td colspan=\"5\"><pre>".PrintPacketPayload($payload, $encoding, 0)."</pre></td></tr>\n";
}//fi
echo "</table>\n";




echo "</body></html>\n";
?>