<?php
//********************************************
// DESCRIPTION
// Classe grant les formulaires
//********************************************
// CREATION :
// 08/04/06 : C. Trussardi
//********************************************


class Formulaire
{
	/**********************************   
	 * Partie prive : les proprits *
	 **********************************/
	 
	 
  var $methode, $script, $nom, $classeCSS; 
  var $modeTable = FALSE,  $orientation, $transfertFichier=0;
  var $entetes=array(), $champs=array(), $nbChamps=0, $nbLignes=0;
  var $contenuForm  = "";


  /********************************
	 * Partie prive : les mthodes *
	 ********************************/  

	
	//***************************************************************************************
  function Formulaire ($pMethode, $pScript, $pClasse="Form", $pNom="Form")
  // Constructeur de la classe
  {
  	$this->methode = $pMethode;
   $this->script = $pScript;
   $this->classeCSS = $pClasse;
   $this->nom = $pNom;
  }//function Formulaire

  
  //***************************************************************************************
  function champINPUT ($pType, $pNom, $pVal, $acces, $pTaille, $pTailleMax)
  // Mthode pour crer un champ INPUT gnral
	{
 		// Cration de la balise
 		if ($pType=="submit")
 		{
   		$s = "<input class=\"bouton\" type=\"".$pType."\" name=\"".$pNom."\" value=\"".$pVal."\" size=\"".$pTaille."\" maxlength=\"".$pTailleMax."\" />\n";
		}
		else
		{	
				switch ($acces)
				{	
					case "w" :
						$s = "<input type=\"".$pType."\" name=\"".$pNom."\" value=\"".$pVal."\" size=\"".$pTaille."\" maxlength=\"".$pTailleMax."\" />\n";
					break;
					
					case "r" :
						$s = "<input type=\"".$pType."\" readonly=\"readonly\" name=\"".$pNom."\" value=\"".$pVal."\" size=\"".$pTaille."\" maxlength=\"".$pTailleMax."\" />\n";
					break;
				}//switch
		}
		// Renvoi de la chane de caractres
    return $s;
  }//function champINPUT


  //****************************************************************************
  function champINPUTDATE ($pType, $pNom, $pVal, $acces, $pTaille, $pTailleMax)
  // Mthode pour crer un champ INPUT date
  {
 		// Cration de la balise
 		switch ($acces)
 		{
 			case "w":
 				$s = "<input type=\"".$pType."\" id=\"".$pNom."\" name=\"".$pNom."\" value=\"".$pVal."\" size=\"".$pTaille."\" maxlength=\"".$pTailleMax."\" readonly=\"readonly\" /><img src=\"".ADRESSE_SITE."/styles/images/calendrier.gif\" id=\"bouton_".$pNom."\" alt=\"\" />\n"
   					."<script type=\"text/javascript\">\n"
    				."	Calendar.setup({\n"
        		."	inputField     :    \"".$pNom."\",\n"
		    		."	ifFormat       :    \"%d/%m/%y\",\n"
    				."	button		     :    \"bouton_".$pNom."\",\n"
       			."	align          :    \"T1\",\n"
       			."	singleClick	   :    true\n"
    				."	});\n"
						."	</script>\n";
			break;
			
			case "r":
				$s = "<input type=\"".$pType."\" id=\"".$pNom."\" readonly=\"readonly\" name=\"".$pNom."\" value=\"".$pVal."\" size=\"".$pTaille."\" maxlength=\"".$pTailleMax."\" readonly=\"readonly\" />\n";
			break;
		}//switch
			
		// Renvoi de la chane de caractres
    return $s;
  }//function champINPUTDATE 


  //****************************************************************************
  function champTEXTAREA ($pNom, $pVal, $acces, $pLig, $pCol)
  // Champ de type texte
	{
		switch ($acces)
		{
			case "w":
				$s = "<textarea name=\"".$pNom."\" rows=\"".$pLig."\" cols=\"".$pCol."\">".$pVal."</textarea>\n";
			break;
			
			case "r":
				$s = "<textarea name=\"".$pNom."\" readonly=\"readonly\" rows=\"".$pLig."\" cols=\"".$pCol."\">".$pVal."</textarea>\n";
			break;
		}//switch
    return $s;
  }//function champTEXTAREA
  

  //****************************************************************************
  function  champSELECT ($pNom, $pListe, $pDefaut, $acces, $pTaille=1)
  // Champ pour slectionner dans une liste
	{
		switch ($acces)
		{
			case "w":
    		$s = "<select name=\"".$pNom."\" size=\"".$pTaille."\">\n";
				while (list ($val, $libelle) = each ($pListe))
    		{
      		if ($libelle != $pDefaut)
			  		$s .= "<option value=\"".$libelle."\">$libelle</option>\n";
      		else
	  				$s .= "<option value=\"".$libelle."\" selected=\"selected\">".$libelle."</option>\n";
    		}
    		$s .= "</select>\n";
    	break;
    	
    	case "r":
    		$s = "<input type=\"text\" name=\"".$pNom."\" readonly=\"readonly\" value=\"".$pDefaut."\" size=\"40\" maxlength=\"40\" />\n";
    	break;
    }//switch
    

    return $s;
  }//function champSELECT
  

	//****************************************************************************
  function  champBUTTONS ($pType, $pNom, $pListe, $pDefaut)
  // Champ CHECKBOX ou RADIO
	{
    // Toujours afficher dans une table
    while (list ($val, $libelle) = each ($pListe))
    {
			$libelles .= "<td>".$libelle."</td>";
      if ($val == $pDefaut) $checked = "checked=\"checked\"";
      else $checked = " ";
      $champs .= "<td><input type=\"".$pType."\" name=\"".$pNom."\" value=\"".$val."\" ".$checked." /></td>\n";
    }
    return  "<table border=\"0\" cellspacing=\"5\" cellpadding=\"2\"><tr>\n" 
               . $libelles .  "</tr>\n<tr>" . $champs . "</tr></table>";
  }//function champBUTTONS

	
	//****************************************************************************
	function champSelectJAVASCRIPT($pNom, $pVal, $acces)
	// champ Select construit  l'aide de javascript : intrt => gestion de listes lies. Cf http://javascript.developpez.com/faq/?page=listeDer#listesLiees
	{		
		switch ($pNom)
		{
			case "demandeur":
				$s="<select name=\"demandeur\" onchange='javascript:filltheselect(this.name, this.value)'>\n"
   				."<script type=\"text/javascript\">\n"
      		."for (i=0; i<membre[\"mthodo\"].length; i++)\n"
					."document.write(\"<option value=\\\"\" +membre[\"mthodo\"][i][0]+ \"\\\">\"+membre[\"mthodo\"][i][1]);\n"
  			 	."</script>\n"
 					."</select> \n";
			break;

			case "affecterPilote":
				$s="<select name=\"affecterPilote\" onchange='javascript:filltheselect(this.name, this.value)'>\n"
   				."<script type=\"text/javascript\">\n"
      		."for (i=0; i<membre[\"mthodo\"].length; i++)\n"
					."document.write(\"<option value=\\\"\" +membre[\"mthodo\"][i][0]+ \"\\\">\"+membre[\"mthodo\"][i][1]);\n" 
  			 	."</script>\n"
					."</select> \n";
			break;
			
			case "adminDemandeur":
				$s="<select name=\"demandeur\" onchange='javascript:filltheselect(this.name, this.value)'>\n"
   				."<script type=\"text/javascript\">\n";
   				if ($pVal != "")
   				{
    				$chemin='/(.*)%(.*)/i';
   					$remplacement1='${1}';
   					$remplacement2='${2}';
   					$uet=preg_replace($chemin, $remplacement1, $pVal);
   					$nom=preg_replace($chemin, $remplacement2, $pVal);
   					
   					$s.="for (i=0; i<membre[\"".$uet."\"].length; i++)\n" 
   						."{\n"
						 	."if(membre[\"".$uet."\"][i][0] != \"".$nom."\")\n"
      				."document.write(\"<option value=\\\"\" +membre[\"mthodo\"][i][0]+ \"\\\">\"+membre[\"mthodo\"][i][1]);\n" 
      				."else\n"
      				."document.write(\"<option selected=\\\"selected\\\" value=\\\"\" +membre[\"".$uet."\"][i][0]+ \"\\\">\"+membre[\"".$uet."\"][i][1]);\n"
      				."}\n";
					}
      		else
      		{	
      			$s.="for (i=0; i<membre[\"mthodo\"].length; i++)\n"
							 ."document.write(\"<option value=\\\"\" +membre[\"mthodo\"][i][0]+ \"\\\">\"+membre[\"mthodo\"][i][1]);\n" ;
					}//fi
					
  			 	$s.="</script>\n"
						 ."</select> \n";
			break;
			
			case "adminAffecterPilote":
				$s="<select name=\"affecterPilote\" onchange='javascript:filltheselect(this.name, this.value)'>\n"
   				."<script type=\"text/javascript\">\n";
   				if ($pVal != "")
   				{
   					$chemin='/(.*)%(.*)/i';
   					$remplacement1='${1}';
   					$remplacement2='${2}';
   					$uet=preg_replace($chemin, $remplacement1, $pVal);
   					$nom=preg_replace($chemin, $remplacement2, $pVal);
   					   					
   					$s.="for (i=0; i<membre[\"".$uet."\"].length; i++)\n" 
   						."{\n"
						 	."if(membre[\"".$uet."\"][i][0] != \"".$nom."\")\n"
      				."document.write(\"<option value=\\\"\" +membre[\"mthodo\"][i][0]+ \"\\\">\"+membre[\"mthodo\"][i][1]);\n" 
      				."else\n"
      				."document.write(\"<option selected=\\\"selected\\\" value=\\\"\" +membre[\"".$uet."\"][i][0]+ \"\\\">\"+membre[\"".$uet."\"][i][1]);\n"
      				."}\n";
					}
      		else
      		{	
      			$s.="for (i=0; i<membre[\"mthodo\"].length; i++)\n"
							 ."document.write(\"<option value=\\\"\" +membre[\"mthodo\"][i][0]+ \"\\\">\"+membre[\"mthodo\"][i][1]);\n" ;
					}//fi
					
  			 	$s.="</script>\n"
						 ."</select> \n";
			break;
			
			case "choixUET":
				$s="<select name=\"choixUET\" onchange='javascript:filltheselect(this.name, this.value)'>\n" 
 		  		."<script type=\"text/javascript\">\n" 
  			  ."for (i=0; i<uet.length; i++)\n" 
  			  ."{\n"
  			  ."if(uet[i][0] != \"".$pVal."\")\n"
      		."document.write(\"<option value=\\\"\" +uet[i][0]+ \"\\\">\"+uet[i][1]);\n" 
      		."else\n"
      		."document.write(\"<option selected=\\\"selected\\\" value=\\\"\" +uet[i][0]+ \"\\\">\"+uet[i][1]);\n" 
   				."}\n"	
					."</script>\n" 
					."</select>\n";
			break;

			case "uetCUET":
				$s="<select name=\"uetCUET\" onchange='javascript:filltheselect(this.name, this.value)'>\n" 
 		  		."<script type=\"text/javascript\">\n" 
  			  ."for (i=0; i<uet.length; i++)\n" 
  			  ."{\n"
  			  ."if(uet[i][0] != \"".$pVal."\")\n"
      		."document.write(\"<option value=\\\"\" +uet[i][0]+ \"\\\">\"+uet[i][1]);\n" 
      		."else\n"
      		."document.write(\"<option selected=\\\"selected\\\" value=\\\"\" +uet[i][0]+ \"\\\">\"+uet[i][1]);\n" 
   				."}\n"	
					."</script>\n" 
					."</select>\n";
			break;
		}//switch
		
		return $s;
	}// function champSelectJAVASCRIPT


  //****************************************************************************
  function champForm ($pType, $pNom, $pVal, $acces, $params, $pListe=array())
  // Champ de formulaire
	{
    switch ($pType)
    {
      case "text": case "password":  
      case "reset": case "file":
            $taille = $params["size"];
            $tailleMax = $params["maxlength"];
            if ($tailleMax == 0) $tailleMax = $taille;
            // Appel de la mthode champINPUT de l'objet courant
            $champ = $this->champINPUT ($pType, $pNom, $pVal, $acces, $taille, $tailleMax);
            // Si c'est un transfert de fichier: s'en souvenir
            if ($pType == "file") $this->transfertFichier=TRUE;
      break;

			case "date":
            $taille = $params["size"];
            $tailleMax = $params["maxlength"];
            if ($tailleMax == 0) $tailleMax = $taille;
            // Appel de la mthode champINPUTDATE de l'objet courant
            $champ = $this->champINPUTDATE ($pType="text", $pNom, $pVal, $acces, $taille, $tailleMax);						
			break;

			case "submit":
            $taille = "";
            $tailleMax = "";
            if ($tailleMax == 0) $tailleMax = $taille;
            // Appel de la mthode champINPUT de l'objet courant
            $champ = $this->champINPUT ($pType, $pNom, $pVal, $acces, $taille, $tailleMax);
      break;
      
      case "textarea": 
            $lig = $params["rows"]; $col = $params["cols"];
            // Appel de la mthode champTEXTAREA de l'objet courant
            $champ = $this->champTEXTAREA ($pNom, $pVal, $acces, $lig, $col);
      break;
    
      case "select":
            $taille = $params["size"];
            // Appel de la mthode champSELECT de l'objet courant
            $champ = $this->champSELECT ($pNom, $pListe, $pVal, $acces, $taille);
      break;

      case "checkbox": case "radio":
            // Appel de la mthode champBUTTONS de l'objet courant
            $champ = $this->champBUTTONS ($pType, $pNom, $pListe, $pVal, $acces);
      break;

			case "selectJavascript":
						//Appel de la methode champSelectJAVASCRIPT
						$champ = $this->champSelectJAVASCRIPT($pNom, $pVal, $acces);
			break;

      default: echo "<strong>ERREUR: ".$pType." est un type inconnu</strong>\n";
      break;
    }
    return $champ;
  }//function champForm
  

  //****************************************************************************************************
  function champLibelle ($pLibelle, $pNom, $pVal, $acces, $pType="text", $params=array(),  $pListe=array())
  // Affichage d'un champ avec son libell
	{
    // Cration du champ
    $champHTML = $this->champForm ($pType, $pNom, $pVal, $acces, $params, $pListe);    

    // Affichage du champ en tenant compte de la prsentation
    if ($this->modeTable)
    {
      if ($this->orientation == VERTICAL)
      { 
        // Nouvelle ligne, avec libell et champ dans deux cellules
        // On l'ajoute dans le contenu
        $this->contenuForm .= "<tr><td>".$pLibelle."</td><td>".$champHTML."</td></tr>\n";
      }
      else
      {
        // On ne peut pas afficher maintenant : on stocke dans les tableaux
        $this->entetes[$this->nbChamps] = $pLibelle;
        $this->champs[$this->nbChamps] = $champHTML;
        $this->nbChamps++;
      }
    }
    else  
    {
      // Affichage simple
      $this->contenuForm .= "$pLibelle  $champHTML";
    }      
  }//function champLibelle
  

  /*******************
	 * Partie publique *
	 *******************/
	 
	 
	//*************************************************************************************************************   
	function champTexte ($pLibelle, $pNom, $pVal, $acces, $pTaille, $pTailleMax=0)
	{ 
    $this->champLibelle ($pLibelle, $pNom, $pVal, $acces, "text", array ("size"=>$pTaille, "maxlength"=>$pTailleMax));
  }//function champTexte


	//*************************************************************************************************************
	function champDate ($pLibelle, $pNom, $pVal, $acces, $pTaille, $pTailleMax=0)
	{ 
    $this->champLibelle ($pLibelle, $pNom, $pVal, $acces, "date", array ("size"=>$pTaille, "maxlength"=>$pTailleMax));
  }//function champDate


	//*************************************************************************************************************
  function champMotDePasse ($pLibelle, $pNom, $pVal, $pTaille, $pTailleMax=0)
  { 
    $this->champLibelle ($pLibelle, $pNom, $pVal, $acces="w", "password", array ("size"=>$pTaille, "maxlength"=>$pTailleMax));
  }//function champMotDePasse


	//****************************************************************************
  function champRadio ($pLibelle, $pNom, $pVal, $pListe)
  {
    $this->champLibelle ($pLibelle, $pNom, $pVal, $acces="w", "radio", array (), $pListe);
  }//function champRadio


	//******************************************************************************************
  function champListe ($pLibelle, $pNom, $pVal, $acces, $pTaille, $pListe)
  {
    $this->champLibelle ($pLibelle, $pNom, $pVal, $acces, "select", array("size"=>$pTaille), $pListe);       
  }//function champListe


	//*******************************************************************************************
	function champListeJavascript ($pLibelle, $pNom, $pVal, $acces)
	{
		$this->champLibelle ($pLibelle, $pNom, $pVal, $acces, "selectJavascript");
	}//champListeJavascriptDemandeur
	
	
	//************************************************************************************************
  function champFenetre ($pLibelle, $pNom, $pVal, $acces, $pLig, $pCol)
  {
    $this->champLibelle ($pLibelle, $pNom, $pVal, $acces, "textarea", array ("rows"=>$pLig,"cols"=>$pCol));       
  }//function champFenetre


	//****************************************************************************
  function champValider ($pLibelle, $pNom)
  {
    $this->champLibelle (" ", $pNom, $pLibelle, $acces="w", "submit");
  }//function champValider


	//***********************************************************************************
  function champFichier ($pLibelle, $pNom, $pTaille)
  {
    $this->champLibelle ($pLibelle, $pNom, "", $acces="w", "file", array ("size"=>$pTaille));
  }//function champFichier


	//*********************************************************************************************
  function champCache ($pNom, $pValeur)
  {
     $this->contenuForm .= "<input type=\"hidden\" name=\"".$pNom."\" id=\"".$pNom."\" value=\"".$pValeur."\" />\n";
  }//function champCache


	//****************************************************************************
  function ajoutTexte ($texte)
  // Ajout d'un texte quelconque 
  {
    $this->contenuForm .= "<tr><td class=\"message\" colspan=\"2\">".$texte."</td></tr>\n";;
  }//function ajoutTexte


  //****************************************************************************
  function debutTable ($orientation=VERTICAL, $classe="")
  // Dbut d'une table, mode horizontal ou vertical
  { 
 	    $this->contenuForm .= "<table class=\"".$classe."\">";
      $this->modeTable = TRUE;
      $this->orientation = $orientation; 
      $this->nbLignes = 1;
      $this->nbChamps = 0;
  }//function debutTable


  //****************************************************************************
  function finTable ()
	// Fin d'une table
  {
    if ($this->modeTable == TRUE) 
    {
     	if ($this->orientation == HORIZONTAL)
     	{
     		// Affichage des libelles
      	$this->contenuForm .= "<tr>\n";
      	// Les enttes du tableau
      	for ($i=0; $i < $this->nbChamps; $i++) 
	     	 $this->contenuForm .= "<td>".$this->entetes[$i]."</td>\n";
  	  	$this->contenuForm .= "</tr>\n";

      	// Affichage des lignes et colonnes
      	for ($j=0; $j < $this->nbLignes; $j++)
      	{
       	 $this->contenuForm .= "<tr>\n";
       	 for ($i=0; $i < $this->nbChamps; $i++) 
       	    $this->contenuForm .= "<td>".$this->champs[$i]."</td>\n";
       	 $this->contenuForm .= "</tr>\n";
      	}//for
     	 }//fi
     	 $this->contenuForm .= "</table>\n";
     }//fi
    $this->modeTable = FALSE;
  }//function finTable

  
  //****************************************************************************
  function fin ($affiche = TRUE)
	// Fin du formulaire, avec affichage ventuel
  {
    // Fin de la table, au cas o on aurait oubli ...
    $this->finTable();

    // On cre le formulaire final en assemblant (1)
    // la balise d'ouverture, (2) le contenu (3) la balise fermante

    // Balise ouvrante: penser  mettre un attribut ENCTYPE 
    // si on transfre un fichier
    if ($this->transfertFichier)
      $encType = "enctype=\"multipart/form-data\"";


    // Ouverture de la balise
    $baliseO = "\n<form  method=\"".$this->methode."\" action=\"".$this->script."\" id=\"".$this->nom."\">\n<fieldset>\n";

    $baliseF =  "</fieldset></form>\n";


    $formulaire = $baliseO . $this->contenuForm . $baliseF;

    // Eventuellement on affiche
    if ($affiche) echo $formulaire;

    // Dans tous les cas on retourne 
    return $formulaire;
  }//function fin

}//classe Formulaire
?>